//---------------------------------------------------------------------------
#ifndef NewBkgH
#define NewBkgH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>

//---------------------------------------------------------------------------
#if (__BORLANDC__ < 0x0530)
//---------------------------------------------------------------------------
// BCB 1.0
//---------------------------------------------------------------------------
  #define PACKAGE

#endif
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
typedef void __fastcall (__closure *TEraseBackgroundEvent)(System::TObject* Sender, TWinControl *RedrawControl );
//---------------------------------------------------------------------------
class PACKAGE TCustomNewBkg : public TComponent
{
private:
protected:
    TEraseBackgroundEvent	FOnEraseBackground;

    int (__stdcall *OldHookFormProc) ();
    int (__stdcall *NewHookFormProc) ();

    TWinControl *FormOwner;
    TWinControl *FBkgOwner;
    HWND   OwnerHandle;

protected:
    void __fastcall SetOwner( TWinControl *Owner );

    void __fastcall HookForm();
    void __fastcall UnhookForm();
	void __fastcall HookFormProc(TMessage &aMsg);

public:
	__fastcall  TCustomNewBkg(TComponent* Owner);
	__fastcall ~TCustomNewBkg();
    
    __property TWinControl *BkgOwner = { read=FBkgOwner, write=SetOwner };
    __property TEraseBackgroundEvent OnEraseBackground = { read=FOnEraseBackground, write=FOnEraseBackground };

__published:
};
//---------------------------------------------------------------------------
class PACKAGE TNewBkg : public TCustomNewBkg
{
private:
protected:
public:
	__fastcall  TNewBkg(TComponent* Owner) : TCustomNewBkg ( Owner ) {}

__published:
  __property BkgOwner;

  __property OnEraseBackground;
};
//---------------------------------------------------------------------------
#endif
